const char metrics_cartridge_failover_lua[] =
"local utils = require('metrics.utils')\n"
"local collectors_list = {}\n"
"local vars = nil\n"
"\n"
"local function update()\n"
"    if vars == nil then\n"
"        local is_cartridge = pcall(require, 'cartridge')\n"
"        if not is_cartridge then\n"
"            return\n"
"        end\n"
"\n"
"        vars = require('cartridge.vars').new('cartridge.failover')\n"
"    end\n"
"\n"
"    local trigger_cnt = vars.failover_trigger_cnt\n"
"    if trigger_cnt ~= nil then\n"
"        collectors_list.trigger_cnt =\n"
"            utils.set_counter(\n"
"                'cartridge_failover_trigger_total',\n"
"                'Count of Cartridge Failover triggers',\n"
"                trigger_cnt,\n"
"                nil,\n"
"                nil,\n"
"                {default = true}\n"
"            )\n"
"    end\n"
"end\n"
"\n"
"return {\n"
"    update = update,\n"
"    list = collectors_list,\n"
"}\n"
""
;
