const char metrics_tarantool_clock_lua[] =
"local utils = require('metrics.utils')\n"
"\n"
"local collectors_list = {}\n"
"\n"
"-- from https://github.com/tarantool/cartridge/blob/cc607f5a6508449608f3953a3f93669e8c8c4ab0/cartridge/issues.lua#L375\n"
"local function update_clock_metrics()\n"
"    local ok, membership = pcall(require, 'membership')\n"
"    if not ok then\n"
"        return\n"
"    end\n"
"\n"
"    local min_delta = 0\n"
"    local max_delta = 0\n"
"\n"
"    for _, member in membership.pairs() do\n"
"        if member and member.status == 'alive' and member.clock_delta ~= nil then\n"
"            if member.clock_delta < min_delta then\n"
"                min_delta = member.clock_delta\n"
"            end\n"
"\n"
"            if member.clock_delta > max_delta then\n"
"                max_delta = member.clock_delta\n"
"            end\n"
"        end\n"
"    end\n"
"\n"
"    collectors_list.clock_delta = utils.set_gauge('clock_delta', 'Clock difference',\n"
"        min_delta * 1e-6, {delta = 'min'}, nil, {default = true})\n"
"    collectors_list.clock_delta = utils.set_gauge('clock_delta', 'Clock difference',\n"
"        max_delta * 1e-6, {delta = 'max'}, nil, {default = true})\n"
"end\n"
"\n"
"return {\n"
"    update = update_clock_metrics,\n"
"    list = collectors_list,\n"
"}\n"
""
;
